/// <reference types="angular" />
/// <reference types="angular-ui-router" />
/// <reference types="angular-translate" />
declare namespace hurbis.ui {
    class Modulo {
        static DEFINICAO: comum.IModuloDefinicao;
        static inicializar(): void;
    }
}
declare namespace hurbis.ui.util {
    class Dispositivo {
        private static mobileDetect;
        private static browserInfo;
        /**
         * Referência de http://www.quirksmode.org/js/detect.html
         **/
        static detectarNavegador(): any;
        static isMobile(): string;
    }
}
declare namespace hurbis.ui.util {
    class Arquivo {
        static baixar(arquivo: comum.util.IArquivo): void;
        private static removerElemento;
    }
}
declare namespace hurbis.ui {
    class Ancora implements angular.IDirective {
        private $location;
        private $anchorScroll;
        constructor($location: angular.ILocationService, $anchorScroll: angular.IAnchorScrollService);
        private static ID;
        restrict: string;
        link: ($scope: angular.IScope, element: angular.IAugmentedJQuery, attributes: angular.IAttributes) => void;
        static inicializar(): void;
    }
}
declare namespace hurbis.ui {
    interface IBloqueadorGestor {
        instances: {
            get(nome: string): IBloqueador;
        };
    }
    interface IBloqueador extends angular.blockUI.BlockUIService {
    }
}
declare namespace hurbis.ui {
    abstract class BaseController implements angular.IController {
        private _bloqueadorGestor;
        readonly bloqueadorGestor: hurbis.ui.IBloqueadorGestor;
        private _$state;
        readonly $state: angular.ui.IStateService;
        private _$filter;
        readonly $filter: angular.IFilterService;
        private _tradutor;
        readonly tradutor: {
            (translationId: string, interpolateParams?: any, interpolation?: string, forceLanguage?: string): string;
        };
        private mensagemFlutante;
        constructor();
        exibirSucesso(texto: string, titulo?: string): void;
        exibirAlerta(texto: string, titulo?: string): void;
        exibirInformacao(texto: string, titulo?: string): void;
        exibirErro(texto: string, titulo?: string): void;
        private exibirMensagem(tipo, texto, titulo?);
        navegar(destino: string, parametro?: any): void;
    }
}
